﻿'メインの一部（ランチメニューのアイテム実行）

'●コードの分割方法。
'ソリューションエクスプローラーのプロジェクト名を右クリック→[追加]→[クラス]→[コードファイル]→クラス名に[Partial]を付けて宣言



Partial Public Class FormMain

    Private Sub MenuItem_MouseDown(sender As System.Object, e As MouseEventArgs)

        '=== アイテムをクリックしたマウスのボタンを記録 ===
        PushedButton = e.Button

    End Sub

    Private Sub MenuItem_MouseUp(sender As System.Object, e As MouseEventArgs)

        '=== 特別なクリック発動 ===
        'メニューの選択は、キーボードでの選択も補足したいのでClickイベントを使いたい。
        'でも、左右以外のクリックはClickイベントで補足できない。
        'なので、改めてイベントを発生させる。
        If e.Button > MouseButtons.Right Then
            DirectCast(sender, ToolStripMenuItem).PerformClick()
        End If

    End Sub

    Private Sub MenuFileItem_Click(sender As System.Object, e As System.EventArgs)

        '=== メニューの実行アイテムがクリックされた ===
        Dim path As String = DirectCast(sender, ToolStripMenuItem).Tag '実行ファイルのパス
        Dim mode As Integer = 0 '拡張コマンドライン引数モード（0=通常, 1=クリップボード転送, 2=オプション編集）
        Dim argumentsList As String = "" 'コマンドライン引数

        '--- コマンドライン引数モードの確定 ---
        If My.Computer.Keyboard.CtrlKeyDown Then

            mode = 2 'Ctrlキーが押されていたら、問答無用でオプション編集モード

        ElseIf My.Computer.Keyboard.ShiftKeyDown Then '安全性を考えたら無い方が良いのかなぁ？

            mode = 1 'Shiftキーが押されていたら、クリップボード転送モード

        ElseIf SystemSettings.LaunchMenu.ExCommandLineOption Then

            '左クリック→通常 / 中クリック→オプション編集 / 右クリック→クリップボード転送
            Select Case PushedButton
                Case MouseButtons.Middle
                    mode = 2
                Case MouseButtons.Right
                    mode = 1
            End Select

        End If

        '--- コマンドライン引数の準備 ---
        If mode >= 1 Then

            'クリップボードの内容を取得
            If Clipboard.ContainsFileDropList Then
                argumentsList = String.Join(" ", From name As String In Clipboard.GetFileDropList Select $"""{name}""") 'フォルダやファイルだった場合は、各要素をダブルクォーテーションで括って空白文字で繋げる。
            ElseIf Clipboard.ContainsText Then
                argumentsList = Clipboard.GetText '文字列だった場合はそのまま転送する。（空白文字を含む場合は、自前でダブルクォーテーションで括らないといけない。）
            End If

        End If

        If mode >= 2 Then

            'コマンドライン引数を編集
            argumentsList = InputBox(String.Format("コマンドライン引数を編集してください。{0}{0}実行アイテム：{0}{1}",
                                                   Environment.NewLine,
                                                   path.Insert(path.LastIndexOf(IO.Path.DirectorySeparatorChar) + 1, Environment.NewLine)), 'アイテム名を解りやすくするために改行を挿入する。
                                     My.Application.Info.Title & " - [オプション編集]",
                                     argumentsList)

            If argumentsList Is Environ(255) Then Exit Sub 'よく分からんけど、《InputBox》で[キャンセル]すると、戻り値が《Environ(255)》になるみたい。これで、""で[OK]した場合と区別できる。ただし、《argumentsList》の宣言時の空文字とは区別できないみたい。

        End If

        '--- 実行 ---
        ItemRun(path, argumentsList)

    End Sub

    Private Sub OpenRegistryDirectory_Click(sender As System.Object, e As System.EventArgs) Handles tsmRegistryFolder.Click

        '=== ランチメニュー登録フォルダを開く ===
        Dim prm As String() = {DirectCast(sender, ToolStripMenuItem).Owner.Tag, Environment.NewLine, "ランチメニュー登録フォルダが", ""}
        '{0=パス, 1=改行文字, 2=定型文, 3=エラー文格納用}

        If IO.Directory.Exists(prm(0)) Then

            Try

                Process.Start(prm(0))

            Catch ex As Exception

                prm(3) = ex.Message
                MessageBox.Show(String.Format("{2}開けませんでした。{1}『{3}』{1}{1}●場所{1}{0}", prm),
                                My.Application.Info.Title,
                                MessageBoxButtons.OK,
                                MessageBoxIcon.Error)

            End Try

        Else

            MessageBox.Show(String.Format("{2}見つかりませんでした。{1}設定や登録内容を見直してください。{1}{1}●場所{1}{0}", prm),
                            My.Application.Info.Title,
                            MessageBoxButtons.OK,
                            MessageBoxIcon.Error)
            LaunchMenuAllNew.Value = True

        End If

    End Sub

    Private Sub BatchRun_Click(sender As System.Object, e As System.EventArgs)

        '=== 同階層の実行アイテムを一括（順次）実行する ===
        For Each item As ToolStripItem In DirectCast(sender, ToolStripMenuItem).Owner.Items

            If item.Tag IsNot Nothing Then
                ItemRun(item.Tag)
                My.Application.DoEvents()
                'Threading.Thread.Sleep(5000) 'インターバルを挟んでも良いけど、起動時間はアプリによってまちまちなんで、あんまり意味ないかも。5秒は、Norton Internet Security 2012の起動マネージャのマネ。
            End If

        Next

        'ショートカットを実行した場合、《p》にプロセスが返されないので、リンク先を取得してexeファイルだったら起動する。
        'この方法だと、起動待ちはできるが、ショートカットに設定したコマンドラインオプションが反映できない。
        'Dim p As System.Diagnostics.Process
        'For Each item As ToolStripItem In DirectCast(sender, ToolStripMenuItem).Owner.Items
        '    Dim target As String = ReturnExeFilePath(item.Tag)
        '    If target <> "" AndAlso System.IO.File.Exists(target) Then
        '        p = System.Diagnostics.Process.Start(target)
        '        p.WaitForInputIdle()
        '    End If
        'Next

    End Sub

    ''' <summary>
    ''' 実行アイテムを実行する
    ''' </summary>
    ''' <param name="FileName">アイテムのパスとファイル名</param>
    ''' <param name="Arguments">コマンドライン引数</param>
    ''' <remarks></remarks>
    Private Sub ItemRun(FileName As String, Optional Arguments As String = "")

        Try

            'Throw New System.IO.FileNotFoundException 'テスト：擬似的にエラーを発生してみる。

            Process.Start(FileName, Arguments)

            'Win32 APIの《ShellExecuteEX》では、動詞に"properties"を指定することで「ファイルのプロパティ」ダイアログを表示できた。(http://hp.vector.co.jp/authors/VA024411/vbtips02.html)
            'なので、《Process.Start》メソッドでも同じようにできるかと期待したけど駄目だった。このメソッドの正体は、《ShellExecute》APIのようだ。
            '当初は、ランチメニューからプロパティ画面の表示をもくろんだが、「登録内容の設定は登録フォルダ内（エクスプローラ）でやる」と役割分担を明確にすることにして、諦めた。

        Catch ex As IO.FileNotFoundException

            MessageBox.Show(String.Format("当該ファイルが、存在しません。{0}{0}●場所{0}{1}", vbCrLf, FileName),
                           My.Application.Info.Title,
                           MessageBoxButtons.OK,
                           MessageBoxIcon.Error)
            LaunchMenuAllNew.Value = True

            'Try構文でエラーを捉えるには、多くのリソースを消費するから、Try構文の前に《System.IO.File.Exists(～)》でファイルの存在確認を済ませておくのが良いと読んだことがある。
            'ここでは、ファイルが存在しないというのは稀な事態でそれ程重要でもないと思うので、Try内で一緒に対処することにした。

        Catch ex As Exception

            MessageBox.Show(String.Format("実行アイテムの実行に失敗しました。{0}{0}『{1}』{0}{0}●場所{0}{2}{0}{0}●コマンドライン引数{0}{3}", vbCrLf, ex.Message, FileName, Arguments),
                            My.Application.Info.Title,
                            MessageBoxButtons.OK,
                            MessageBoxIcon.Error)

        End Try

    End Sub

    ' ''' <summary>
    ' ''' ショートカットアイコンのリンク先が、exeファイルだったらそのパスを返す（使ってません・・・）
    ' ''' </summary>
    ' ''' <param name="Path">調べたいパス</param>
    ' ''' <returns>exeファイルならそのパスを、違ったら空文字を返す。</returns>
    ' ''' <remarks></remarks>
    'Private Function ReturnExeFilePath(Path As String) As String

    '    Dim ret As String = ""

    '    If System.IO.Path.GetExtension(Path).Equals(".exe", StringComparison.OrdinalIgnoreCase) Then

    '        ret = Path

    '    ElseIf System.IO.Path.GetExtension(Path).Equals(".lnk", StringComparison.OrdinalIgnoreCase) Then

    '        'WSHでショートカットアイコンのリンク先を取得する（ショートカット作成方法からの派生）。
    '        Dim oShell As Object = CreateObject("WScript.Shell")
    '        Dim oShortcut As Object = oShell.CreateShortcut(Path)
    '        Dim linkTarget As String = oShortcut.TargetPath

    '        If System.IO.Path.GetExtension(linkTarget).Equals(".exe", StringComparison.OrdinalIgnoreCase) Then
    '            ret = linkTarget '& " " & oShortcut.Arguments'←これを付けるとコマンドラインオプションも返せるが、その文字列からファイルのパスを取得できずファイルの存在チェックなどができなくなる。
    '        End If

    '    End If

    '    Return ret

    'End Function

End Class
