﻿''' <summary>
''' 時間設定
''' </summary>
Public Class StepTimeAdjuster

    ''' <summary>
    ''' 現在の時間を取得する
    ''' </summary>
    ''' <returns></returns>
    Public ReadOnly Property Time As Integer
        Get
            Return nudTime.Value
        End Get
    End Property

    ''' <summary>
    ''' 現在の間隔を取得する
    ''' </summary>
    ''' <returns></returns>
    Public ReadOnly Property Interval As Integer
        Get
            Return nudInterval.Value
        End Get
    End Property

    ''' <summary>
    ''' 初期化
    ''' </summary>
    ''' <param name="time">時間</param>
    ''' <param name="interval">間隔</param>
    ''' <param name="maximum">最大値</param>
    ''' <remarks></remarks>
    Public Sub Initialize(time As Integer, interval As Integer, maximum As Integer)

        nudTime.Maximum = maximum
        nudTime.Increment = interval
        nudTime.Value = Math.Min(time, maximum)
        nudInterval.Value = interval

    End Sub

    Private Sub nudInterval_ValueChanged(sender As Object, e As EventArgs) Handles nudInterval.ValueChanged

        '=== 間隔を変更 ===
        nudTime.Increment = nudInterval.Value

    End Sub

    Private Sub nudTime_ValueChanged(sender As Object, e As EventArgs) Handles nudTime.ValueChanged

        '=== 機能停止の表示 ===
        lblStatus.Visible = nudTime.Value = 0

    End Sub

End Class
